
#include "AppEvent.Ch"
#include "DcBitMap.Ch"
#include "DcCursor.Ch"
#include "DcDialog.Ch"
#include "DcGra.Ch"
#include "DcIcon.Ch"
#include "Inkey.Ch"
#include "Set.Ch"
#include "Xbp.Ch"

#define VK_NUMLOCK        0x90
#define VK_SCROLL         0x91
#define VK_CAPITAL        0x14
#define APPKEY_PRESSED    2

FUNCTION Main

  LOCAL GetList  := {}, GetOptions, oGroup, lStatus, oStatBar, oMsgStatic, oInsStatic, oNumStatic, oCapsStatic, oMsgBox

  PRIVATE cRecid := "F2", cFormId := "FA", cCode, cDesc, cForm, cFormDesc, nFinal, nDebt, nColor, oButton

  DC_Gui(.t.)
  DC_SetKeyActive(.t.)
  DC_GetPopupCaption({ '12.Arial Bold', BITMAP_SCAN_M, 0 })
  DC_GetPopupAutoHide(.t.)

  DC_AppendMode(1)
  Set Deleted On

  SELECT 0
  USE Pef200 INDEX CodeMx01, CodeMx02  ALIAS CodeAlt
  SELECT 0
  USE Pef200 INDEX CodeMx01, CodeMx02  ALIAS CodeMst

  SELECT CodeAlt
  SET ORDER TO 1
  SELECT CodeMst
  SET ORDER TO 1

  nGroup       := 1
  lStatus      := .f.
  lNewRec      := .f.
  cCode        := Space(4)
  cDesc        := Space(45)
  lConviction  := .f.
  lPaid        := .f.
  cForm        := Space(4)
  cFormDesc    := Space(35)
  nFinal       := 0
  nDebt        := 0
  nColor       := 0
  cPaid        := Space(4)
  cPaidDesc    := ""
  cDefault     := Space(4)
  cDefaultDesc := ""
  cCollect     := Space(4)
  cCollectDesc := ""
  cBankCode    := Space(4)
  cBankDesc    := ""

  GetCodes()


  @  1.00, 1.00 DCGROUP oGroup         CAPTION ' Disposition Code '                 SIZE 86,10.00                                                         COLOR GRA_CLR_BLUE

  @  1.25, 2.00 DCSAY 'Disposition Code'                                                                                         PARENT oGroup            COLOR GRA_CLR_BLUE
  @  1.00,20.00 DCGET cCode            Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
					 TABSTOP ;
				    NOCONFIRM ;
                GETID "Get_cCode" ;
                WHEN {|| nGroup == 1 } ;
                TABGROUP XBP_BEGIN_GROUP ;
                VALID {|| ValidateCode(cCode, GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, cRecid, GetList) } ;
                MESSAGE 'Enter The Disposition Code To Be Maintained.' INTO oMsgBox

  @   .80,30.00 DCCHECKBOX lConviction PROMPT '  Conviction'                                                                     PARENT oGroup            COLOR GRA_CLR_BLUE ;
  	             WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                CURSOR { Nil, POINTER_PEN_1, Nil }

  @   .80,43.00 DCCHECKBOX lPaid       PROMPT '  Paid'                                                                           PARENT oGroup            COLOR GRA_CLR_BLUE ;
  	             WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                CURSOR { Nil, POINTER_PEN_1, Nil }

  @  2.50, 2.00 DCSAY 'Disposition Description '                                    SIZE  0                                      PARENT oGroup            COLOR GRA_CLR_BLUE
  @  2.25,20.00 DCGET cDesc            Picture '!XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX'                                   PARENT oGroup            COLOR GRA_CLR_BLACK ;
				    PROPER ;
                GETID "Get_cDesc" ;
                WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                MESSAGE "Enter Disposition Description."  INTO oMsgBox

  @  3.75, 2.00 DCSAY 'Form Type'                                                   SIZE  0                                      PARENT oGroup            COLOR GRA_CLR_BLUE
  @  3.50,20.00 DCGET cForm            Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
                GETID "Get_cForm" ;
                WHEN {|| nGroup == 2 } ;
                TABGROUP XBP_WITHIN_GROUP ;
                VALID {|| ValidateForm(cForm, GetList) } ;
                POPUP {|c| c := GuiFormScan(c, cFormid, GetList) } ;
                MESSAGE "Enter Form Type Code."  INTO oMsgBox

  @  3.75,30.00 DCSAY {|| cFormDesc }                                               SAYSIZE 35                                   PARENT oGroup            COLOR GRA_CLR_BLUE

  @  5.00, 2.00 DCSAY 'Default Paid'                                                                                             PARENT oGroup            COLOR GRA_CLR_BLUE
  @  4.75,20.00 DCGET cPaid            Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
				    NOCONFIRM ;
                GETID "Get_cPaid" ;
                WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                VALID {|| ValidatePaid(cPaid,GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, cRecid, GetList) } ;
                MESSAGE 'Enter The Default "Paid" Code for Pre-Paid Disposition.' INTO oMsgBox

  @  5.00,30.00 DCSAY {|| cPaidDesc }                                               SAYSIZE 35                                   PARENT oGroup            COLOR GRA_CLR_BLUE

  @  6.25, 2.00 DCSAY 'Default Order'                                                                                            PARENT oGroup            COLOR GRA_CLR_BLUE
  @  6.00,20.00 DCGET cDefault         Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
				    NOCONFIRM ;
                GETID "Get_cDefault" ;
                WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                VALID {|| ValidateDefault(cDefault,GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, cRecid, GetList) } ;
                MESSAGE 'Enter The "Default Order" Code for Disposition Code.' INTO oMsgBox

  @  6.25,30.00 DCSAY {|| cDefaultDesc }                                            SAYSIZE 35                                   PARENT oGroup            COLOR GRA_CLR_BLUE

  @  7.50, 2.00 DCSAY 'Collections'                                                                                              PARENT oGroup            COLOR GRA_CLR_BLUE
  @  7.25,20.00 DCGET cCollect         Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
				    NOCONFIRM ;
                GETID "Get_cCollect" ;
                WHEN {|| !Empty(cCode) } ;
                TABGROUP XBP_WITHIN_GROUP ;
                VALID {|| ValidateCollect(cCollect,GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, cRecid, GetList) } ;
                MESSAGE 'Enter The Collections Code For Disposition Code.' INTO oMsgBox

  @  7.50,30.00 DCSAY {|| cCollectDesc }                                            SAYSIZE 35                                   PARENT oGroup            COLOR GRA_CLR_BLUE

  @  8.75, 2.00 DCSAY 'Bankruptcy'                                                                                               PARENT oGroup            COLOR GRA_CLR_BLUE
  @  8.50,20.00 DCGET cBankCode        Picture '!!!!'                                                                            PARENT oGroup            COLOR GRA_CLR_BLACK ;
				    NOCONFIRM ;
                GETID "Get_cBankCode" ;
                TABGROUP XBP_END_GROUP ;
                WHEN {|| !Empty(cCode) } ;
                VALID {|| ValidateBank(cBankCode,GetList) } ;
                POPUP {|c| c := GuiCodeScan(c, cRecid, GetList) } ;
                MESSAGE 'Enter the Bankruptcy Code For Disposition Code.' INTO oMsgBox

  @  8.75,30.00 DCSAY {|| cBankDesc }                                               SAYSIZE 35                                   PARENT oGroup            COLOR GRA_CLR_BLUE


  @  1.00,74.00 DCPUSHBUTTONXP         CAPTION {|| 'Display;Color' }                SIZE 10.00, 2.40                             PARENT oGroup  ;
                RADIUS 0 ;
                GRADIENT  1.10 ;
					 OBJECT oButton ;
                BORDERCOLOR {255,153,51} ;
					 WHEN {|| !Empty(cCode) } ;
                ACTION {|a,b,o| nColor := SetColor(nColor, GetList), o:bgColor := nColor, o:bgColorMouse := nColor, o:bgColorClick := nColor, o:invalidateRect() }



  @ 11.25, 1.00 DCPUSHBUTTON           CAPTION {|| IIF(lNewRec,'Add','Update') }    SIZE  9, 1.20 ;
                WHEN {|| !Empty(cCode) } ;
                ACTION {|| CodeAction(IIF(lNewRec,1,2),GetList) }

  @ 11.25,12.00 DCPUSHBUTTON           CAPTION 'Delete'                             SIZE  9, 1.20 ;
                ACTION {|| CodeAction(3,GetList) } ;
                WHEN {|| !lNewRec .AND. !Empty(cCode) }

  @ 11.25,23.00 DCPUSHBUTTON           CAPTION 'Cancel'                             SIZE  9, 1.20 ;
                CARGO 'CANCEL' ;
                WHEN {|| !Empty(cCode) } ;
                ACTION {|| CodeAction(0,GetList) }

  @ 11.25,34.00 DCPUSHBUTTON           CAPTION 'Exit'                               SIZE  9, 1.20 ;
                CARGO 'CANCEL' ;
                ACTION {|| DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }


  DCSTATUSBAR oStatBar  HEIGHT 25  ALIGN DCGUI_ALIGN_BOTTOM  SPACING 0

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			                  SIZE 300,20    PIXEL     OBJECT oMsgStatic   PARENT oStatBar

  @  2.00, 2.00 DCMESSAGEBOX TYPE XBPSTATIC_TYPE_TEXT                               SIZE 300,20    PIXEL     OBJECT oMsgBox      PARENT oMsgStatic        COLOR GRA_CLR_BLUE, GRA_CLR_BACKGROUND

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			                  SIZE 30,20     PIXEL     OBJECT oCapsStatic  PARENT oStatBar

  @  1.00, 1.00 DCSAY ''  ID 'CAPSLOCK'                                             SAYSIZE 28,18  PIXEL     SAYCENTER           PARENT oCapsStatic

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			                  SIZE 30,20     PIXEL     OBJECT oNumStatic   PARENT oStatBar

  @  1.00, 1.00 DCSAY ''   ID 'NUMLOCK'                                             SAYSIZE 28,18  PIXEL     SAYCENTER           PARENT oNumStatic

  @  3.00, 0.00 DCSTATIC TYPE XBPSTATIC_TYPE_RECESSEDBOX 			                  SIZE 30,20     PIXEL     OBJECT oInsStatic   PARENT oStatBar

  @  1.00, 1.00 DCSAY ''   ID 'INSERT'                                              SAYSIZE 28,18  PIXEL     SAYCENTER           PARENT oInsStatic

  DCHOTKEY K_INS ACTION {|| ReadInsert(!ReadInsert()) }

  DCGETOPTIONS ;
    CASCADE ;
    SOURCEFILE __FILEPATH__


  DCREAD GUI ;
         FIT ;
			MODAL ;
         OPTIONS GetOptions ;
         TITLE ' Maintain Disposition Code ' ;
			EVAL {|o| SetTimerEvent(100,{|| _UpdateStats(GetList)}) }

	SetTimerEvent(0)

RETURN Nil

*---

STATIC FUNCTION CodeAction( nAction, GetList )

  IF nAction == 1 .OR. nAction == 2              // add record

    SELECT CodeMst
	 SET ORDER TO 1
	 SEEK cRecid + cCode
	 IF Eof()
		APPEND BLANK
    ENDIF
    IF DC_RecLock(5)                                    // Update Record Text
      REPLACE CmRecid     WITH cRecid
      REPLACE CmCode      WITH cCode
      REPLACE CmDesc      WITH cDesc
      REPLACE CmCalc      WITH lConviction
      REPLACE CmLog1      WITH lPaid
      REPLACE CmLink      WITH cForm
      REPLACE CmStart     WITH nFinal
      REPLACE CmEnd       WITH nDebt
      REPLACE CmValue     WITH nColor
      UNLOCK
    ENDIF

	 IF !Empty(cPaid)
		SEEK "MVPAID"
		IF Eof()
		  APPEND BLANK
      ENDIF
		IF DC_RecLock(5)
        REPLACE CmRecid   WITH "MV"
        REPLACE CmCode    WITH "PAID"
        REPLACE CmLink    WITH cPaid
        REPLACE CmDesc    WITH "Default Paid Disposition Code."
        UNLOCK
      ENDIF
    ENDIF

	 IF !Empty(cDefault)
		SEEK "MVDFLT"
		IF Eof()
		  APPEND BLANK
      ENDIF
		IF DC_RecLock(5)
        REPLACE CmRecid   WITH "MV"
        REPLACE CmCode    WITH "DFLT"
        REPLACE CmLink    WITH cDefault
        REPLACE CmDesc    WITH "Default Order Code."
        UNLOCK
      ENDIF
    ENDIF

	 IF !Empty(cCollect)
		SEEK "MVCOLL"
		IF Eof()
		  APPEND BLANK
      ENDIF
		IF DC_RecLock(5)
        REPLACE CmRecid   WITH "MV"
        REPLACE CmCode    WITH "COLL"
        REPLACE CmLink    WITH cCollect
        REPLACE CmDesc    WITH "Sent to Collection Agency."
        UNLOCK
      ENDIF
    ENDIF

	 IF !Empty(cBankCode)
		SEEK "MVBANK"
		IF Eof()
		  APPEND BLANK
      ENDIF
		IF DC_RecLock(5)
        REPLACE CmRecid   WITH "MV"
        REPLACE CmCode    WITH "BANK"
        REPLACE CmLink    WITH cBankCode
        REPLACE CmDesc    WITH "Bankruptcy Action Filed."
        UNLOCK
      ENDIF
    ENDIF

  ELSEIF nAction == 3                             // delete record

    SELECT CodeMst
	 SET ORDER TO 1
	 SEEK cRecid + cCode
    IF !Eof()
      IF DC_RecLock(5)
        DELETE
        UNLOCK
      ENDIF
    ENDIF

  ENDIF

  nGroup       := 1
  lNewRec      := .f.
  cCode        := Space(4)
  cDesc        := Space(45)
  lConviction  := .f.
  lPaid        := .f.
  cForm        := Space(4)
  cFormDesc    := Space(35)
  nFinal       := 0
  nDebt        := 0
  nColor       := 0
  cPaid        := Space(4)
  cPaidDesc    := ""
  cDefault     := Space(4)
  cDefaultDesc := ""
  cCollect     := Space(4)
  cCollectDesc := ""
  cBankCode    := Space(4)
  cBankDesc    := ""

  GetCodes()

  DC_ReadGuiEvent(DCGUI_MOVE_TOP, GetList)
  DC_GetRefresh(GetList)

RETURN Nil

*---

STATIC FUNCTION ValidateCode( cCode, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK cRecid + cCode

  IF !Eof()
    lNewRec              := .f.
    cDesc                := CodeMst->CmDesc
    lConviction          := CodeMst->CmCalc
    lPaid                := CodeMst->CmLog1
    cForm                := CodeMst->CmLink
    nFinal               := CodeMst->CmStart
    nDebt                := CodeMst->CmEnd
    nColor               := CodeMst->CmValue

    oButton:bgColor      := nColor
    oButton:bgColorMouse := nColor
    oButton:bgColorClick := nColor
    oButton:invalidateRect()

    SELECT CodeAlt
    SET ORDER TO 1
    SEEK "FA" + cForm
    IF Eof()
      cFormDesc          := ""
    ELSE
      cFormDesc          := AllTrim(CodeAlt->CmDesc)
    ENDIF
  ELSE
    lNewRec              := .t.
  ENDIF

  nGroup                 := 2
  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION ValidatePaid( cPaid, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK cRecid + cPaid

  IF Eof()
    cPaidDesc := ""
  ELSE
    cPaidDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN cPaidDesc

*---

STATIC FUNCTION ValidateDefault( cDefault, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK cRecid + cDefault

  IF Eof()
    cDefaultDesc := ""
  ELSE
    cDefaultDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN cDefaultDesc

*---

STATIC FUNCTION ValidateCollect( cCollect, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK cRecid + cCollect

  IF Eof()
    cCollectDesc := ""
  ELSE
    cCollectDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN cCollectDesc

*---

STATIC FUNCTION ValidateBank( cBank, GetList )

  SELECT CodeMst
  SET ORDER TO 1
  SEEK cRecid + cBank

  IF Eof()
    cBankDesc := ""
  ELSE
    cBankDesc := AllTrim(CodeMst->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN cBankDesc

*---

STATIC FUNCTION GuiCodeScan(c, cRecid, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25)

  SELECT CodeMst
  SET ORDER TO 2
  CodeMst->(DC_SetScope(0,cRecid))
  CodeMst->(DC_SetScope(1,cRecid))
  CodeMst->(DC_DbGotop())

  SET ORDER TO 1
  CodeMst->(DC_SetScope(0,cRecid))
  CodeMst->(DC_SetScope(1,cRecid))
  CodeMst->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)

  bColor    := {|| GraMakeRGBColor(GraGetRGBIntensity(CodeMst->CmValue)), Nil }


  @  1.00, 1.00 DCGET cSeek      Picture '@!'                                  KEYBLOCK {|a,b,o| _Mvp660( a, b, o, oBrowse, @cSeek ) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse ALIAS 'CodeMst'                               SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeMst->CmCode}                         HEADER 'Disposition;Code'                   WIDTH  8  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeMst->CmDesc)}                HEADER ';Disposition Description'           WIDTH 25  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'} } ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCBROWSECOL   DATA  {|| CodeMst->CmLink }                       HEADER 'Form;Code'                          WIDTH  3  PARENT oBrowse
  DCBROWSECOL   DATA  {|| CodeMst->CmStart }                      HEADER 'Final;Notice'                       WIDTH  3  PARENT oBrowse
  DCBROWSECOL   DATA  {|| IIF(CodeMst->CmLog1,"Yes", "No") }      HEADER 'Paid;Status'                        WIDTH  5  PARENT oBrowse ;
					 ALIGN 5                                                             // Align Center [horizontal & vertical]
  DCBROWSECOL   DATA  {|| CodeMst->CmEnd }                        HEADER 'Debt;Notice'                        WIDTH  3  PARENT oBrowse
  DCBROWSECOL   DATA  {|| GraGetRGBIntensity(CodeMst->CmValue) }  HEADER 'Display;Color'                      WIDTH  8  PARENT oBrowse ;
					 EVAL { |a| a:colorBlock := bColor }
  DCBROWSECOL   DATA  {|| "Color" }                               HEADER 'Display;Color'                      WIDTH  4  PARENT oBrowse ;
					 EVAL { |a| a:colorBlock := bColor }
  DCBROWSECOL   DATA  {|| IIF(CodeMst->CmCalc,"Yes", "No") }      HEADER 'Liable;Disposition'                 WIDTH  6  PARENT oBrowse ;
					 ALIGN 5   COLOR bColor                                              // Align Center [horizontal & vertical]

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Select Desired Disposition Code' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    nGroup               := 2
    lNewRec              := .f.
	 cCode                := CodeMst->CmCode
    cDesc                := CodeMst->CmDesc
    lConviction          := CodeMst->CmCalc
    lPaid                := CodeMst->CmLog1
    cForm                := CodeMst->CmLink
    nFinal               := CodeMst->CmStart
    nDebt                := CodeMst->CmEnd
    nColor               := CodeMst->CmValue

    oButton:bgColor      := nColor
    oButton:bgColorMouse := nColor
    oButton:bgColorClick := nColor
    oButton:invalidateRect()

	 SELECT CodeAlt
	 SET ORDER TO 1
	 SEEK "FA" + cForm
    IF Eof()
      cFormDesc          := ""
    ELSE
      cFormDesc          := AllTrim(CodeAlt->CmDesc)
    ENDIF

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cDesc"))

  ELSE

    nGroup               := 1
    lNewRec              := .t.
    cCode                := Space(4)
    cDesc                := Space(45)
    lConviction          := .f.
    lPaid                := .f.
    cForm                := Space(4)
    cFormDesc            := Space(35)
    nFinal               := 0
    nDebt                := 0
    nColor               := 0

    DC_GetRefresh(aGetList)
    SetAppFocus(DC_GetObject(aGetList,"Get_cCode"))

  ENDIF

  SELECT CodeMst
  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cCode

*---

STATIC FUNCTION ValidateForm( cForm, GetList )

  SELECT CodeAlt
  SET ORDER TO 1
  SEEK "FA" + cForm
  IF Eof()
    cFormDesc := ""
  ELSE
    cFormDesc := AllTrim(CodeAlt->CmDesc)
  ENDIF

  DC_GetRefresh(GetList)

RETURN .t.

*---

STATIC FUNCTION GuiFormScan(c, cForm, aGetList)

  LOCAL GetList[0], GetOptions, oBrowse, aPres, aBrowPres, aSort, aSort2[8], cSeek := Space(25)

  SELECT CodeAlt
  SET ORDER TO 2
  CodeAlt->(DC_SetScope(0,cForm))
  CodeAlt->(DC_SetScope(1,cForm))
  CodeAlt->(DC_DbGotop())

  SET ORDER TO 1
  CodeAlt->(DC_SetScope(0,cForm))
  CodeAlt->(DC_SetScope(1,cForm))
  CodeAlt->(DC_DbGotop())

  aPres     := DC_BrowPres()
  aSort     := DC_BrowseSort()

  aBrowPres := {{ XBP_PP_COL_HA_FGCLR, GRA_CLR_BLACK },             /* Header FG Color  */  ;
                { XBP_PP_COL_HA_BGCLR, GRA_CLR_PALEGRAY },          /* Header BG Color  */  ;
                { XBP_PP_COL_DA_ROWSEPARATOR, XBPCOL_SEP_DOTTED },  /* Row Sep          */  ;
                { XBP_PP_COL_DA_COLSEPARATOR, XBPCOL_SEP_DOTTED },  /* Col Sep          */  ;
                { XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK },             /* Row FG Color     */  ;
                { XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE },             /* Row BG Color     */  ;
                { XBP_PP_COL_DA_ROWHEIGHT, 11 },                    /* Row Height       */  ;
                { XBP_PP_COL_DA_CELLHEIGHT, 11 },                   /* Cell Height      */  ;
                { XBP_PP_COL_HA_HEIGHT, 12 },                       /* Header Height    */  ;
                { XBP_PP_COL_DA_HILITE_FGCLR, GRA_CLR_BLUE },       /* Cursor FG Color  */  ;
                { XBP_PP_COL_DA_HILITE_BGCLR, GRA_CLR_PALEGRAY},    /* Cursor BG Color  */  ;
                { XBP_PP_HILITE_FGCLR, GRA_CLR_WHITE },             /* Hilite FG color  */  ;
                { XBP_PP_HILITE_BGCLR, GRA_CLR_BLUE },              /* Hilite BG color  */  ;
                { XBP_PP_COL_FA_FGCLR, GRA_CLR_WHITE },             /* Footer FG Color  */  ;
                { XBP_PP_COL_FA_BGCLR, GRA_CLR_PALEGRAY },          /* Footer BG Color  */  ;
                { XBP_PP_COL_DA_COMPOUNDNAME,'9.Arial'},            /* Font             */  ;
                { XBP_PP_COL_HA_COMPOUNDNAME,'9.Helv'},             /* Font             */  ;
                { XBP_PP_COL_FA_HEIGHT, 12 },                       /* Footer Height    */  ;
                { XBP_PP_COL_HA_ALIGNMENT,XBPALIGN_HCENTER}         /* Header Alignment */  ;
               }

  aSort2[1] := GRA_CLR_RED              // Sort Selected Color (Foreground)                     // PC CAW 01-13-05
  aSort2[2] := GRA_CLR_PALEGRAY         // Sort Selected Color (Background)
  aSort2[3] := GRA_CLR_BLACK            // Sort Unselectable Color (Foreground)
  aSort2[4] := GRA_CLR_PALEGRAY         // Sort Unselectable Color (Background)
//  aSort2[5] := Nil                    // No Longer Utilized
//  aSort2[6] := Nil                    // No Longer Utilized
  aSort2[7] := GRA_CLR_BLACK            // Sort Unselected Color (Foreground) - Able to select
  aSort2[8] := GRA_CLR_PALEGRAY         // Sort Unselected Color (Background) - Able to select

  DC_BrowPres(aBrowPres)                                           // save browse presentation factors

  DC_BrowseSort(aSort2)


  @  1.00, 1.00 DCGET cSeek      Picture '@!'                                  KEYBLOCK {|a,b,o| _Mvp660( a, b, o, oBrowse, @cSeek ) } ;
                GETID "Get_cSeek"

  @  2.50, 1.00 DCBROWSE oBrowse ALIAS 'CodeAlt'                               SIZE 50,20 ;
  			       FIT ;
  			       SCOPE ;
			       NOHSCROLL ;
			       HEADLINES 2 ;
  			       NOSOFTTRACK ;
                PRESENTATION DC_BrowPres() ;
			       CURSORMODE XBPBRW_CURSOR_ROW ;
                SORTUPBITMAP BITMAP_RD_UP_RED ;
                SORTDOWNBITMAP BITMAP_RD_DOWN_RED ;
                SORTSCOLOR GRA_CLR_RED, GRA_CLR_PALEGRAY ;
                SORTUCOLOR GRA_CLR_BLACK, GRA_CLR_PALEGRAY ;
  			       ITEMSELECTED { || DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList) }

  DCBROWSECOL   DATA {|| CodeAlt->CmCode}               HEADER 'Form;Code'                   WIDTH  6  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX01')} LEFTBUTTON ;
                _DEFAULT OrdSetFocus() == 'CODEMX01'

  DCBROWSECOL   DATA {|| AllTrim(CodeAlt->CmDesc)}      HEADER ';Form Description'           WIDTH 25  PARENT oBrowse ;
  	             PRESENTATION {{XBP_PP_COL_HA_COMPOUNDNAME, '9.Helv Bold'}} ;
                SORT {|| OrdSetFocus('CODEMX02')} LEFTBUTTON

  DCREAD GUI TO lStatus ;
         FIT ;
         MODAL ;
         ADDBUTTONS ;
	      TITLE 'Pick Desired Form Type Code' ;
         EVAL { || SetAppFocus(DC_GetObject(GetList,"Get_cSeek")) }

  IF lStatus

    cForm     := CodeAlt->CmCode
    cFormDesc := CodeAlt->CmDesc

  ENDIF

  DC_GetRefresh(aGetList)
  SetAppFocus(DC_GetObject(aGetList,"Get_cForm"))

  SELECT CodeAlt
  SET ORDER TO 1
  DC_ClrScope()
  SET ORDER TO 2
  DC_ClrScope()

  DC_BrowPres(aPres)                                           // save browse presentation factors
  DC_BrowseSort(aSort)

RETURN cForm

*---

STATIC FUNCTION _Mvp660( a, b, o, oBrowse, cSeek )

  LOCAL lClearBuffer := .t., lSoftSeek := Set(_SET_SOFTSEEK, .t.)

  IF     a == xbeK_UP
    oBrowse:up()
  ELSEIF a == xbeK_DOWN
    oBrowse:down()
  ELSEIF a == xbeK_PGUP
    oBrowse:pageUp()
  ELSEIF a == xbeK_PGDN
    oBrowse:pageDown()
  ELSEIF a == xbeK_END
    oBrowse:goBottom()
  ELSEIF a == xbeK_HOME
    oBrowse:goTop()
  ELSE
    SEEK cRecId + AllTrim(o:EditBuffer())
    lClearBuffer := .f.
  ENDIF

  oBrowse:refreshAll()

  IF lClearBuffer
    cSeek := Space(25)
    o:Get:home()
    o:setData()
  ENDIF

  Set(_SET_SOFTSEEK,lSoftSeek)

RETURN Nil

*---

STATIC FUNCTION SetColor( nColor, GetList )

  LOCAL nSaveColor := nColor

  nColor   := GraMakeRGBColor(DC_PopColor( GraGetRGBIntensity( nColor ), 2, .t., 'Choose Button Color', .t. ) )

  IF nColor == Nil
    nColor := nSaveColor
  ENDIF

  DC_GetRefresh(GetList)

RETURN nColor

*---

STATIC FUNCTION GetCodes()

  SELECT CodeMst
  SET ORDER TO 1
  SEEK "MVPAID"
  IF Eof()
	 cPaid          := Space(4)
	 cPaidDesc      := ""
  ELSE
	 cPaid          := CodeMst->CmLink
    SEEK cRecid + cPaid
	 IF Eof()
	   cPaidDesc    := ""
	 ELSE
	   cPaidDesc    := AllTrim(CodeMst->CmDesc)
	 ENDIF
  ENDIF
  SEEK "MVDFLT"
  IF Eof()
	 cDefault       := Space(4)
	 cDefaultDesc   := ""
  ELSE
	 cDefault       := CodeMst->CmLink
    SEEK cRecid + cDefault
	 IF Eof()
	   cDefaultDesc := ""
	 ELSE
	   cDefaultDesc := AllTrim(CodeMst->CmDesc)
    ENDIF
  ENDIF
  SEEK "MVCOLL"
  IF Eof()
	 cCollect       := Space(4)
	 cCollectDesc   := ""
  ELSE
	 cCollect       := CodeMst->CmLink
    SEEK cRecid + cCollect
	 IF Eof()
	   cCollectDesc := ""
	 ELSE
	   cCollectDesc := AllTrim(CodeMst->CmDesc)
    ENDIF
  ENDIF
  SEEK "MVBANK"
  IF Eof()
	 cBankCode      := Space(4)
	 cBankDesc      := ""
  ELSE
	 cBankCode      := CodeMst->CmLink
    SEEK cRecid + cBankCode
	 IF Eof()
	   cBankDesc    := ""
	 ELSE
	   cBankDesc    := AllTrim(CodeMst->CmDesc)
    ENDIF
  ENDIF

RETURN Nil

*---

STATIC FUNCTION _UpdateStats( GetList )

  LOCAL oCapsLock := DC_GetObject(GetList,'CAPSLOCK')
  LOCAL oNumLock  := DC_GetObject(GetList,'NUMLOCK')
  LOCAL oInsert   := DC_GetObject(GetList,'INSERT')
  LOCAL lCaps     := AppKeyState( VK_CAPITAL,.t. )
  LOCAL lNum      := AppKeyState( VK_NUMLOCK,.t. )

  IF lNum == APPKEY_PRESSED
    oNumLock:SetCaption( "Num" )
  ELSE
    oNumLock:SetCaption( "" )
  ENDIF

  IF lCaps == APPKEY_PRESSED
    oCapsLock:SetCaption( "Caps" )
  ELSE
    oCapsLock:SetCaption( "" )
  ENDIF

  IF ReadInsert()
    oInsert:SetCaption( "Ins" )
  ELSE
    oInsert:SetCaption( "Ovr" )
  ENDIF

RETURN Nil

*---

PROCEDURE AppSys
RETURN





















